-#! /bin/sh
+#!/bin/sh
# Copyright 2011 Dvir Volk <dvirsk at gmail dot com>. All rights reserved.
#
exit 1
fi
+
#Read the redis port
read -p "Please select the redis port for this instance: [$_REDIS_PORT] " REDIS_PORT
if [ ! `echo $REDIS_PORT | egrep "^[0-9]+\$"` ] ; then
#render the tmplates
TMP_FILE="/tmp/$REDIS_PORT.conf"
-TPL_FILE="./redis.conf.tpl"
+DEFAULT_CONFIG="../redis.conf"
INIT_TPL_FILE="./redis_init_script.tpl"
INIT_SCRIPT_DEST="/etc/init.d/redis_$REDIS_PORT"
PIDFILE="/var/run/redis_$REDIS_PORT.pid"
CLI_EXEC=`dirname $REDIS_EXECUTABLE`"/redis-cli"
fi
-#Generate config file from template
+#Generate config file from the default config file as template
+#changing only the stuff we're controlling from this script
echo "## Generated by install_server.sh ##" > $TMP_FILE
-cat $TPL_FILE | while read line; do eval "echo \"$line\"" >> $TMP_FILE; done
+
+SED_EXPR="s#^port [0-9]{4}\$#port ${REDIS_PORT}#;\
+s#^logfile .+\$#logfile ${REDIS_LOG_FILE}#;\
+s#^dir .+\$#dir ${REDIS_DATA_DIR}#;\
+s#^pidfile .+\$#pidfile ${PIDFILE}#;\
+s#^daemonize no\$#daemonize yes#;"
+echo $SED_EXPR
+sed -r "$SED_EXPR" $DEFAULT_CONFIG >> $TMP_FILE
+
+#cat $TPL_FILE | while read line; do eval "echo \"$line\"" >> $TMP_FILE; done
cp -f $TMP_FILE $REDIS_CONFIG_FILE || exit 1
#Generate sample script from template file
# Provides: redis_6379\n
# Required-Start: $network $local_fs $remote_fs\n
# Required-Stop: $network $local_fs $remote_fs\n
+# Default-Start: 2 3 4 5\n
+# Default-Stop: 0 1 6\n
# Should-Start: $syslog $named\n
# Should-Stop: $syslog $named\n
# Short-Description: start and stop redis_6379\n
# Description: Redis daemon\n
### END INIT INFO\n\n"
-if [[ ! `which chkconfig` ]] ; then
+if [ !`which chkconfig` ] ; then
#combine the header and the template (which is actually a static footer)
- echo -e $REDIS_INIT_HEADER > $TMP_FILE && cat $INIT_TPL_FILE >> $TMP_FILE || die "Could not write init script to $TMP_FILE"
+ echo $REDIS_INIT_HEADER > $TMP_FILE && cat $INIT_TPL_FILE >> $TMP_FILE || die "Could not write init script to $TMP_FILE"
else
#if we're a box with chkconfig on it we want to include info for chkconfig
echo -e $REDIS_INIT_HEADER $REDIS_CHKCONFIG_INFO > $TMP_FILE && cat $INIT_TPL_FILE >> $TMP_FILE || die "Could not write init script to $TMP_FILE"
#Install the service
echo "Installing service..."
-if [[ ! `which chkconfig` ]] ; then
+if [ !`which chkconfig` ] ; then
#if we're not a chkconfig box assume we're able to use update-rc.d
update-rc.d redis_$REDIS_PORT defaults && echo "Success!"
else
# we're chkconfig, so lets add to chkconfig and put in runlevel 345
chkconfig --add redis_$REDIS_PORT && echo "Successfully added to chkconfig!"
- chkconfig--level 345 redis_$REDIS_PORT on && echo "Successfully added to runlevels 345!"
+ chkconfig --level 345 redis_$REDIS_PORT on && echo "Successfully added to runlevels 345!"
fi
/etc/init.d/redis_$REDIS_PORT start || die "Failed starting service..."